git-submodule: forward exit code of git-submodule--helper more faithfully

git-submodule--helper is invoked as the upstream of a pipe in several
places. Usually, the failure of a program in this position is not
detected by the shell. For this reason, the code inserts a token in the
output stream when git-submodule--helper fails that is detected
downstream, where the shell script is quit with exit code 1.

There happens to be a bug in git-submodule--helper that leads to a
segmentation fault. The test suite triggers the crash in several places,
all of which are protected by 'test_must_fail'. But due to the inspecific
exit code 1, the crash remains undiagnosed.

Extend the failure protocol such that git-submodule--helper's exit code
is passed downstream (only in the case of failure). This enables the
downstream to use it as its own exit code, and 'test_must_fail' to
identify the segmentation fault as an unexpected failure.

The bug itself is fixed in the next commit.

Signed-off-by: Johannes Sixt <j6t@kdbg.org>
Acked-by: Stefan Beller <sbeller@google.com>
Signed-off-by: Junio C Hamano <gitster@pobox.com>
This commit is contained in:
Johannes Sixt 2016-07-22 21:14:38 +02:00 committed by Junio C Hamano
parent bb2d8a817d
commit c4c02bf16c
3 changed files with 15 additions and 15 deletions

View file

@ -50,7 +50,7 @@ die_if_unmatched ()
{
if test "$1" = "#unmatched"
then
exit 1
exit ${2:-1}
fi
}
@ -312,11 +312,11 @@ cmd_foreach()
{
git submodule--helper list --prefix "$wt_prefix" ||
echo "#unmatched"
echo "#unmatched" $?
} |
while read mode sha1 stage sm_path
do
die_if_unmatched "$mode"
die_if_unmatched "$mode" "$sha1"
if test -e "$sm_path"/.git
then
displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
@ -423,11 +423,11 @@ cmd_deinit()
{
git submodule--helper list --prefix "$wt_prefix" "$@" ||
echo "#unmatched"
echo "#unmatched" $?
} |
while read mode sha1 stage sm_path
do
die_if_unmatched "$mode"
die_if_unmatched "$mode" "$sha1"
name=$(git submodule--helper name "$sm_path") || exit
displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
@ -580,12 +580,12 @@ cmd_update()
${depth:+--depth "$depth"} \
${recommend_shallow:+"$recommend_shallow"} \
${jobs:+$jobs} \
"$@" || echo "#unmatched"
"$@" || echo "#unmatched" $?
} | {
err=
while read mode sha1 stage just_cloned sm_path
do
die_if_unmatched "$mode"
die_if_unmatched "$mode" "$sha1"
name=$(git submodule--helper name "$sm_path") || exit
url=$(git config submodule."$name".url)
@ -993,11 +993,11 @@ cmd_status()
{
git submodule--helper list --prefix "$wt_prefix" "$@" ||
echo "#unmatched"
echo "#unmatched" $?
} |
while read mode sha1 stage sm_path
do
die_if_unmatched "$mode"
die_if_unmatched "$mode" "$sha1"
name=$(git submodule--helper name "$sm_path") || exit
url=$(git config submodule."$name".url)
displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
@ -1074,11 +1074,11 @@ cmd_sync()
cd_to_toplevel
{
git submodule--helper list --prefix "$wt_prefix" "$@" ||
echo "#unmatched"
echo "#unmatched" $?
} |
while read mode sha1 stage sm_path
do
die_if_unmatched "$mode"
die_if_unmatched "$mode" "$sha1"
name=$(git submodule--helper name "$sm_path")
url=$(git config -f .gitmodules --get submodule."$name".url)

View file

@ -18,7 +18,7 @@ test_expect_success 'setup repository with submodules' '
git commit -m "add submodules"
'
test_expect_success 'clone with recurse-submodules fails' '
test_expect_failure 'clone with recurse-submodules fails' '
test_must_fail git clone --recurse-submodules . dst
'
@ -32,7 +32,7 @@ test_expect_success 'update of ssh allowed' '
git -C dst submodule update ssh-module
'
test_expect_success 'update of ext not allowed' '
test_expect_failure 'update of ext not allowed' '
test_must_fail git -C dst submodule update ext-module
'

View file

@ -352,7 +352,7 @@ test_expect_success 'sync should fail with unknown submodule' '
test_failure_with_unknown_submodule sync
'
test_expect_success 'update should fail when path is used by a file' '
test_expect_failure 'update should fail when path is used by a file' '
echo hello >expect &&
echo "hello" >init &&
@ -361,7 +361,7 @@ test_expect_success 'update should fail when path is used by a file' '
test_cmp expect init
'
test_expect_success 'update should fail when path is used by a nonempty directory' '
test_expect_failure 'update should fail when path is used by a nonempty directory' '
echo hello >expect &&
rm -fr init &&